/*********************************************************************
----------------------------------------------------------------------
File    : main.c
Purpose : Sample program for CortexM
--------- END-OF-HEADER --------------------------------------------*/

#include "main.h"

/*********************************************************************
*
*       main
*
*********************************************************************/

volatile int Cnt;

void SystemInit (void) {
  //
  // Initialize flash controller
  // Otherwise application will not run stand-alone and not after "reset" is clicked in debugger
  //
  // FSMC clock enable
  *(volatile unsigned int*)(0x40023838) = 0x00000001;
  // GPIOD~G clock enable
  *(volatile unsigned int*)(0x40023830) = 0x000001FF;
  // GPIOD config
  *(volatile unsigned int*)(0x40020C00) = 0xAAAAAA0A;
  *(volatile unsigned int*)(0x40020C08) = 0xFFFFCF0F;
  *(volatile unsigned int*)(0x40020C20) = 0xCCCC00CC;
  *(volatile unsigned int*)(0x40020C24) = 0xCCCCCCCC;
  // GPIOE config
  *(volatile unsigned int*)(0x40021000) = 0xAAAAAAAA;
  *(volatile unsigned int*)(0x40021008) = 0xFFFFFFFF;
  *(volatile unsigned int*)(0x40021020) = 0xCCCCCCCC;
  *(volatile unsigned int*)(0x40021024) = 0xCCCCCCCC;
  // GPIOF config
  *(volatile unsigned int*)(0x40021400) = 0xAA000AAA;
  *(volatile unsigned int*)(0x40021408) = 0xFF000FFF;
  *(volatile unsigned int*)(0x40021420) = 0x00CCCCCC;
  *(volatile unsigned int*)(0x40021424) = 0xCCCC0000;
  // GPIOG config
  *(volatile unsigned int*)(0x40021800) = 0x02A80AAA;
  *(volatile unsigned int*)(0x40021808) = 0x03FC0FFF;
  *(volatile unsigned int*)(0x40021820) = 0x00CCCCCC;
  *(volatile unsigned int*)(0x40021824) = 0x000CCCC0;
  // FSMC config
  *(volatile unsigned int*)(0xA0000000) = 0x00001059;
  *(volatile unsigned int*)(0xA0000004) = 0x20000705;
  *(volatile unsigned int*)(0xA0000104) = 0x20000705;
}

//
// This function is placed in external CFI NOR flash.
//
void __attribute__((section(".ExtFlash"))) Delay(int LoopCnt) {
  while(LoopCnt--);
}

int main(void) {
  Cnt = 0;
  while (1) {
    Cnt++;
    Cnt++;
    Cnt++;
    Delay(1000);
    Cnt++;
    Cnt++;
    Cnt++;
    Cnt++;
    Cnt++;
    Cnt++;
    Delay(1000);
    Cnt++;
    Cnt++;
    Cnt++;
    Cnt++;
    Delay(1000);
    Cnt++;
    Cnt++;
    Cnt++;
    Cnt++;
  }
  return 0;
}

